<template>
  <div>
    <gp-collapsible-toolbar :persistent="entries.persistent"
                            :items="entries.visible"
                            :hidden="entries.hidden"
                            :breakpoint="breakpoint"
                            right>
      <template #help>
        <rui-help-button-content :caption="$t('js.garden.patches.actions.help.caption')" :content="$t('js.garden.patches.actions.help.content')" :lines="helpLines" />
      </template>
    </gp-collapsible-toolbar>
  </div>
</template>

<script>
import { markRaw } from 'vue'
import { handledBreakpoints } from '../../../../plugins/Breakpoints'
import { shapeIcons } from '../../../../shapeIcons'
import Patch from '../../../../classes/models/Patch'

import Toaster from '../../../../tools/Toaster'

import RuiHelpButtonContent from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButtonContent.vue'

import GpCollapsibleToolbar from '../../../../common/CollapsibleToolbar/CollapsibleToolbar.vue'
import GpaPatchDestroyWarning from './_DestroyWarning.vue'

const RawDestroyWarning = markRaw(GpaPatchDestroyWarning)

const actionsContexts = {
  default: {
    persistent: ['add_resource'],
    visible: ['separator', 'add_observation', 'show_observations', 'separator', 'add_task'],
    hidden: ['separator', 'transform', 'rotate', 'move', 'separator', 'edit', 'destroy'],
  },
  inventory: {
    persistent: ['add_resource', 'separator'],
    hidden: ['separator', 'edit', 'destroy'],
  },
}

export const availableContexts = Object.keys(actionsContexts)

export default {
  name: 'GpaPatchActions',
  components: { RuiHelpButtonContent, GpCollapsibleToolbar },
  props: {
    patch: { required: true, type: Patch },
    context: { required: false, type: String, default: 'default', validator: v => availableContexts.includes(v) },
    breakpoint: { required: false, type: String, default: 'small', validator: (v) => handledBreakpoints.includes(v) },
  },
  data () {
    const helpLines = []
    if (this.$props.patch.geometryType !== 'Point') {
      helpLines.push({ icon: 'plus-circle', text: this.$t('js.garden.patches.actions.help.add_resource') })
    }

    helpLines.push({ icon: 'observations', text: this.$t('js.garden.patches.actions.help.new_observation') })
    helpLines.push({ icon: 'notebook', text: this.$t('js.garden.patches.actions.help.show_observations') })
    helpLines.push({ icon: 'calendar-plus', text: this.$t('js.garden.patches.actions.help.new_task') })

    if (!this.$props.patch.isVirtual) {
      helpLines.push({ icon: shapeIcons[this.$props.patch.geometryType].edit, text: this.$t('js.garden.patches.actions.help.edit_geometry') })
      helpLines.push({ icon: 'arrow-clockwise', text: this.$t('js.garden.patches.actions.help.rotate') })
      helpLines.push({ icon: 'arrows-out-cardinal', text: this.$t('js.garden.patches.actions.help.move') })
    }

    helpLines.push({ icon: 'pencil', text: this.$t('js.garden.patches.actions.help.edit') })
    helpLines.push({ icon: 'trash', text: this.$t('js.garden.patches.actions.help.destroy') })

    return {
      shapeIcons,
      helpLines,
    }
  },
  computed: {
    actions () {
      return {
        add_resource: {
          icon: 'plus-circle',
          caption: this.$t('js.layouts.garden.info.add_resource'),
          variant: 'creative',
          onclick: () => { this.addElement() },
          condition: () => this.patch.geometryType !== 'Point',
        },

        add_observation: {
          icon: 'observations',
          caption: this.$t('js.layouts.garden.info.add_patch_observation'),
          onclick: () => { this.$emitBus('show-observation-form', this.patch) },
        },
        show_observations: {
          icon: 'notebook',
          caption: this.$t('js.elements.action_buttons.show_observations'),
          disabled: this.patch.observationsCount === 0,
          onclick: () => { this.$emitBus('show-observations', this.patch) },
        },
        add_task: {
          icon: 'calendar-plus',
          caption: this.$t('js.layouts.garden.info.add_patch_task'),
          onclick: () => { this.$emitBus('show-task-form', this.patch) },
        },

        transform: {
          icon: shapeIcons[this.patch.geometryType].edit,
          caption: this.$t('js.generic.transform'),
          onclick: () => { this.$emitBus('transform-patch', this.patch) },
          condition: () => !this.patch.isVirtual,
        },
        rotate: {
          icon: 'arrow-clockwise',
          caption: this.$t('js.generic.rotate'),
          onclick: () => { this.$emitBus('rotate-patch', this.patch) },
          condition: () => !this.patch.isVirtual,
        },
        move: {
          icon: 'arrows-out-cardinal',
          caption: this.$t('js.generic.move'),
          condition: () => !this.patch.isVirtual,
        },

        edit: {
          icon: 'pencil',
          caption: this.$t('generic.edit'),
          onclick: () => { this.$emitBus('show-patch-form', this.patch) },
        },
        destroy: {
          icon: 'trash',
          caption: this.$t('generic.destroy'),
          variant: 'destructive',
          onclick: () => { this.destroy() },
        },
      }
    },
    entries () {
      const list = { visible: [], hidden: [], persistent: [] }
      Object.keys(actionsContexts[this.context]).forEach((visibility) => {
        actionsContexts[this.context][visibility].forEach((entry) => {
          // Avoid two consecutive separators
          if (entry === 'separator' && list[visibility][list[visibility].length - 1] === 'separator') return
          if (this.actions[entry]?.condition && !this.actions[entry].condition()) return

          list[visibility].push(entry === 'separator' ? 'separator' : this.actions[entry])
        })
      })

      return list
    },
  },
  methods: {
    destroy () {
      this.$emitBus('ask-confirmation', {
        component: RawDestroyWarning,
        caption: this.$t('js.patch.destroy_title'),
        callback: () => {
          this.$store.dispatch('destroyPatch', this.$props.patch.id)
            .then(() => { Toaster.success(this.$t('js.patch.successfully_destroyed')) })
            .catch(() => { Toaster.error(this.$t('js.patch.failed_to_destroy')) })
        },
      })
    },
    addElement () {
      this.$emitBus('show-patch-resource-picker', this.$props.patch)
    },
  },
}
</script>
